import java.util.*;
import processing.sound.*;

Random random;
BufferedReader reader;
PrintWriter writer;

public PImage ground;
public PImage ground2;
public PImage groundClean;

public PImage cactus;
public PImage cactus2;
public PImage cactus3;

public PImage drone;
public  PImage clone;

public PImage convention1;
public PImage convention2;

public  PImage road1;
public  PImage road2;
public  PImage road3;
public  PImage road4;
public  PImage road5;
public  PImage road6;
public  PImage road7;
public  PImage road8;
public  PImage road9;
public  PImage road10;
public  PImage road11;
public  PImage road12;
public  PImage road13;
public  PImage road14;
public  PImage road15;
public  PImage road16;

public  PImage carUp;
public  PImage carDown;
public  PImage carRight;
public  PImage carLeft;

public PImage end1;
public PImage end2;
public PImage end3;
public PImage end4;
public PImage end5;

public PImage mountains;
public PImage enemy;
public PImage enemy2;

public PFont font26;
public PFont font70;

public int score;
public int highScore;

static SoundFile music;
static SoundFile music2;
SoundFile type1;
SoundFile type2;
SoundFile smash;
SoundFile abduct;

void setup() {
  enemy2 = loadImage("sprites/enemy/enemy2.png");
  surface.setIcon(enemy2);
  surface.setTitle("Swarm Saucers");
  size(1088,640); //tilemap is 17x10. tiles are 64x64 px
  noSmooth();
  level = new Level(0,false);
  frameRate(60);
  
  try {
    reader = createReader("save");
    highScore = Integer.parseInt(reader.readLine());
  } catch (Exception e) {
    highScore = 0;
  }
  score = 0;

random = new Random();
  
music = new SoundFile(this, "sound/music.wav");
music2 = new SoundFile(this, "sound/music2.wav");
type1 = new SoundFile(this, "sound/type1.wav");
type2 = new SoundFile(this, "sound/type2.wav");
smash = new SoundFile(this, "sound/smash.wav");
abduct = new SoundFile(this, "sound/abduct.wav");
  
ground = loadImage("sprites/Ground.png");
ground2 = loadImage("sprites/Ground2.png");
groundClean = loadImage("sprites/GroundClean.png");

cactus = loadImage("sprites/Cactus.png");
cactus2 = loadImage("sprites/Cactus2.png");
cactus3 = loadImage("sprites/Cactus3.png");

drone = loadImage("sprites/enemy/Drone.png");
clone = loadImage("sprites/enemy/Clone.png");

convention1 = loadImage("sprites/convention1.png");
convention2 = loadImage("sprites/convention2.png");

road1 = loadImage("sprites/road/RoadAlone.png");
road2 = loadImage("sprites/road/DeadEndDown.png");
road3 = loadImage("sprites/road/DeadEndLeft.png");
road4 = loadImage("sprites/road/DeadEndRight.png");
road5 = loadImage("sprites/road/DeadEndUp.png");
road6 = loadImage("sprites/road/RoadHorizontal.png");
road7 = loadImage("sprites/road/RoadIntersectionAllWays.png");
road8 = loadImage("sprites/road/RoadIntersectionDown.png");
road9 = loadImage("sprites/road/RoadIntersectionLeft.png");
road10 = loadImage("sprites/road/RoadIntersectionRight.png");
road11 = loadImage("sprites/road/RoadIntersectionUp.png");
road12 = loadImage("sprites/road/RoadTurnLeftDown.png");
road13 = loadImage("sprites/road/RoadTurnRightDown.png");
road14 = loadImage("sprites/road/RoadTurnUpLeft.png");
road15 = loadImage("sprites/road/RoadTurnUpRight.png");
road16 = loadImage("sprites/road/RoadVertical.png");

carUp = loadImage("sprites/car/CarUp.png");
carDown = loadImage("sprites/car/CarDown.png");
carRight = loadImage("sprites/car/CarRight.png");
carLeft = loadImage("sprites/car/CarLeft.png");

end1 = loadImage("sprites/end/layer1.png");
end2 = loadImage("sprites/end/layer2.png");
end3 = loadImage("sprites/end/layer3.png");
end4 = loadImage("sprites/end/layer4.png");
end5 = loadImage("sprites/end/layer5.png");

mountains = loadImage("sprites/mountains.png");
enemy = loadImage("sprites/enemy/enemy.png");

font26 = createFont("font.ttf",26,false);
font70 = createFont("font.ttf",70,false);

}
void keyPressed() {
  recentlyPressed = true;
  if (keyCode==DOWN||keyCode==UP||keyCode==LEFT||keyCode==RIGHT) {
    setMove(keyCode,true);
    lastKey = keyCode;
  }
}
void keyReleased() {
  recentlyPressed = false;
  if (keyCode==DOWN||keyCode==UP||keyCode==LEFT||keyCode==RIGHT) {
    setMove(keyCode, false);
    lastKey = keyCode;
  }
}
int lastKey = RIGHT;
boolean isUp; boolean isDown; boolean isLeft; boolean isRight;
boolean setMove(int k, boolean b) {
    switch (k) {
    case DOWN:
      return isUp = b;
    case UP:
      return isDown = b;
    case LEFT:
      return isLeft = b;
    case RIGHT:
      return isRight = b;
    default:
      return b;
    }
}
public Boolean recentlyPressed = false;
public int currentLevel = 0;
Boolean onGame = true;
StoryDisplay story = new StoryDisplay(1);
EndScene endscene;
Boolean temp = false;
Boolean end = false;

int period;
int pMillis = millis();

void draw() {
  period = millis() - pMillis;
  pMillis = millis();
  clear();
  if (onGame) {
    temp = level.drawEverything();
    if (temp&&level.won==false) {
      level = new Level(currentLevel,true);
    }
    if (temp&&level.won==true) {
      onGame = false; currentLevel++;
      level = new Level(currentLevel,false);
      try {
        story = new StoryDisplay(currentLevel);
      } catch (NullPointerException e) {
        end = true;
        if (highScore == 0)
          endscene = new EndScene(true);
        else {
          endscene = new EndScene(false);
          if (score < highScore) {
            endscene.better = true;
          }
        }
        if (score <= highScore || highScore == 0) {
          highScore = score;
          writer = createWriter(dataPath("save"));
          writer.println(score);
          writer.flush(); writer.close();
        }
        SoundManager.startSound(2);
      }
    }
  } else {
    if (end) {
      if (endscene.update()) {
        recentlyPressed = false;
        end = false;
        story = new StoryDisplay(1);
        currentLevel = 0;
        level = new Level(currentLevel,false);
        onGame = true;
        score = 0;
      }
    } else {
        if (story.update()) {
          onGame = true;
        }
    }
  }
  if (highScore != 0) {
    fill(#ffffff);
    textAlign(RIGHT);
    textFont(font26);
    text("HI " + scoreInSeconds(highScore) + "s", 1088,20);
    text("SCR " + String.format("%-5s", scoreInSeconds(score) ).replace(' ', '0') + "s", 1088,45);
    textAlign(LEFT);
  }
  SoundManager.update();
}
public static float scoreInSeconds(int score) {
  return round((float)score/(float)60,3);
}
public static float round(float number, int scale) {
    int pow = 10;
    for (int i = 1; i < scale; i++)
        pow *= 10;
    float tmp = number * pow;
    return ( (float) ( (int) ((tmp - (int) tmp) >= 0.5f ? tmp + 1 : tmp) ) ) / pow;
}

class EndScene {
  public Boolean better = false;
  Boolean didUnlock;
  EndScene(Boolean unlock) {
    didUnlock = unlock;
  }
  Boolean reallyOver = false;
  float timeMultiplier1;
  float timeMultiplier2;
  float timeMultiplier4;
  float timeMultiplier5;
  float time = 2.2;
  float y = 640;
  Boolean update() {
    //time+=0.002;
    time+= 0.00012*period;
    timeMultiplier1 = 1/(time*4)+0.544;
    timeMultiplier2 = 1/(time*3)+0.4;
    timeMultiplier4 = 1/(time*2)+0.4;
    timeMultiplier5 = 1/(time)+0.4;
    
    float sizeX = 2000*timeMultiplier1;
    float sizeY = 1457*timeMultiplier1;
    image(end1,(1088-sizeX)/2,(640-sizeY)/2,sizeX,sizeY);
    sizeX = 2000*timeMultiplier2;
    sizeY = 1457*timeMultiplier2;
    image(end2,(1088-sizeX)/2,(640-sizeY)/2,sizeX,sizeY);
    sizeX = 2000*timeMultiplier4;
    sizeY = 1457*timeMultiplier4;
    image(end4,(1088-sizeX)/2,(640-sizeY)/2,sizeX,sizeY);
    sizeX = 2000*timeMultiplier5;
    sizeY = 1457*timeMultiplier5;
    image(end5,(1088-sizeX)/2,(640-sizeY)/2,sizeX,sizeY);
    
    y-=0.06*period;
    image(end3,1088/2,y,1136/4,3064/4);
    
    textAlign(CENTER);
    stroke(#ffffff);
    textFont(font70);
    if (didUnlock) {
      text("You unlocked score mode!",1088/2,640/2);
    } else if (better) {
      text("You beat your old high score!",1088/2,640/2);
    } else {
      text("Yay, butterkase!",1088/2,640/2);
    }
    if (didUnlock||better) {
      noFill();
      stroke(#ffffff);
      strokeWeight(4);
      final int xMov = 859; final int yMov = 230;
      bezier(8.7*20+xMov,-8.7*20+yMov,8.6*20+xMov,-6.3*20+yMov,7.83*20+xMov,-4.13*20+yMov,6.14*20+xMov,-2.9*20+yMov);
      line(8.7*20+xMov,-8.7*20+yMov,8.7*20+xMov+8,-8.7*20+yMov+15);
      line(8.7*20+xMov,-8.7*20+yMov,8.7*20+xMov-10,-8.7*20+yMov+14);
    }
    textAlign(LEFT);
    
    if (reallyOver&&recentlyPressed) {
      SoundManager.stopSound(2);
      return true;
    }
    if (!recentlyPressed)
      reallyOver = true;
    return false;
  }
}

public Level.Car car;
public Level level;

class Level {
  Boolean retry;
  Level(int levelNum, Boolean attempt) {
    lvlNum = levelNum;
    readLevel();
    retry = attempt;
  }
  int lvlNum;
  Boolean crashedYet = false;
  float abductHeight = 5*64;
  float upAcc = 0;
  Boolean startedSound = false;
  Boolean stoppedSound = false;
  public Boolean drawEverything() {
    if (!stoppedSound&&dead) {
      stoppedSound = true;
      SoundManager.stopSound(1);
    }
    if (lvlNum!=0&&lvlNum!=6&&!startedSound&&fadeOut==0) {
      startedSound = true;
      SoundManager.startSound(1);
    }
    if (!dead&&fadeOut>0) {
      fadeOut -= 0.14*period;
    }
    for (int x = -10; x < 17; x++) {
      for (int y = 0; y < 10; y++) {
        image(groundClean,x*64+y*50,y*64);
      }
    }
    for (Entity e : roads) {
      e.drawSprite();
    }
    if (!dead) {
      if (fadeOut ==0&&lvlNum!=6)
        car.update();
    }else
      fadeOut+=0.14*period;
    for (int x = -10; x < 17; x++) {
      for (int y = 0; y < 10; y++) {
        if ((x/8+y/6)%2==0)
          image(ground,x*64+y*50,y*64);
        else
          image(ground2,x*64+y*50,y*64);
      }
    }
    for (Entity e : roads) {
      e.drawSprite();
    }
    if (lvlNum==5) {
      if (!crashedYet)
        image(convention1,11*64,abductHeight,64*2,64*2);
      else
        image(convention2,11*64,abductHeight,64*2,64*2);
      if (!crashedYet&&car.x>11*64+15) {
        smash.play();
        crashedYet = true;
        won = true;
        dead = true;
      }
    }
    if (lvlNum==6) {
      fill(-2270405);
      rect(11*64+64-45,5*64+64-10,64,64);
      image(convention2,11*64,abductHeight,64*2,64*2);
      image(clone, 11*64-10+64-15-10, abductHeight+64-15-134,32*2,84*2);
      if (fadeOut==0) {
        if (upAcc==0)
          abduct.play();
        upAcc += 0.0036*period;
      }
      abductHeight-=upAcc;
      if (abductHeight < -120) {
        won = true; dead = true;
      }
    }
    if (!crashedYet&&lvlNum!=6&&(!dead||won))
      car.drawSprite();
    for (Entity e : cacti) {
      e.drawSprite();
    }
    if (!crashedYet&&lvlNum!=6&&dead&&!won)
      car.drawSprite();
    if (!dead&&fadeOut==0&&lvlNum!=6) {
      for (Entity e : aliens) {
        e.update();
      }
    }
    if (lvlNum!=6) {
      for (Entity e : aliens) {
        e.drawSprite();
      }
    }
    if (lvlNum==0) {
      image(mountains,0,0);
      image(enemy,20,20);
    }
    if (fadeOut>255)
      fadeOut = 255;
    if (fadeOut<0)
      fadeOut = 0;
    if (lvlNum!=0&&!won&&fadeOut==0&&lvlNum!=6)
      score+= 0.06*period;
    fill(0,fadeOut);
    noStroke();
    rect(0,0,1088,640);
    if (!dead&&!retry&&lvlNum!=0)
      story.fadeText(fadeOut);
    if (lvlNum==0)
      titleScreen();
    if (dead&&fadeOut==255)
      return true;
    return false;
  }
  public void titleScreen() {
    fill(#ffffff);
    textFont(font70);
    text("SWARM SAUCERS",100,100);
    if (car.x < 200) {
      textFont(font26);
      text("Wrong way! I need to get to the cheese convention.",25,400);
    }
  }
  abstract class Entity {
    float x; float y;
    int h; int w;
    Entity(int xTemp, int yTemp) {
      x = xTemp; y = yTemp;
      h = 64; w = 64;
    }
    public abstract void update();
    public abstract void drawSprite();
    public void drawHitBox() {
      rect(x,y,w,h);
    }
    public boolean touching(Entity e) {
      return x < e.x + e.w && x + w > e.x && y < e.y + e.h && y + h > e.y;
    }
  }
  class Road extends Entity {
    Road(int x, int y) {
      super(x,y);
    }
    public void update() {}
    void reorient() {
      Boolean up = false; Boolean down = false;
      Boolean left = false; Boolean right = false;
      y++; if (touchingRoads(this)) {down=true;} y--;
      y--; if (touchingRoads(this)) {up=true;} y++;
      x++; if (touchingRoads(this)) {right=true;} x--;
      x--; if (touchingRoads(this)) {left=true;} x++;
      if (up==true&&down==false&&right==false&&left==false)
        type = 2; //"DeadEndDown.png";
      else if (up==false&&down==false&&right==true&&left==false)
        type = 3; //"DeadEndLeft.png";
      else if (up==false&&down==false&&right==false&&left==true)
        type = 4; //"DeadEndRight.png";
      else if (up==false&&down==true&&right==false&&left==false)
        type = 5; //"DeadEndUp.png";
      else if (up==false&&down==false&&right==true&&left==true)
        type = 6; //"RoadHorizontal.png";
      else if (up==true&&down==true&&right==true&&left==true)
        type = 7; //"RoadIntersectionAllWays.png";
      else if (up==false&&down==true&&right==true&&left==true)
        type = 8; //"RoadIntersectionDown.png";
      else if (up==true&&down==true&&right==false&&left==true)
        type = 9; //"RoadIntersectionLeft.png";
      else if (up==true&&down==true&&right==true&&left==false)
        type = 10; //"RoadIntersectionRight.png";
      else if (up==true&&down==false&&right==true&&left==true)
        type = 11; //"RoadIntersectionUp.png";
      else if (up==false&&down==true&&right==false&&left==true)
        type = 12; //"RoadTurnLeftDown.png";
      else if (up==false&&down==true&&right==true&&left==false)
        type = 13; //"RoadTurnRightDown.png";
      else if (up==true&&down==false&&right==false&&left==true)
        type = 14; //"RoadTurnUpLeft.png";
      else if (up==true&&down==false&&right==true&&left==false)
        type = 15; //"RoadTurnUpRight.png";
      else if (up==true&&down==true&&right==false&&left==false)
        type = 16; //"RoadVertical.png";
    }
    int type = 1; //"RoadAlone.png";
    void drawSprite() {
      switch (type) {
        case 1:
          image(road1, x, y,64,64);
          break;
        case 2:
          image(road2, x, y,64,64);
          break;
        case 3:
          image(road3, x, y,64,64);
          break;
        case 4:
          image(road4, x, y,64,64);
          break;
        case 5:
          image(road5, x, y,64,64);
          break;
        case 6:
          image(road6, x, y,64,64);
          break;
        case 7:
          image(road7, x, y,64,64);
          break;
        case 8:
          image(road8, x, y,64,64);
          break;
        case 9:
          image(road9, x, y,64,64);
          break;
        case 10:
          image(road10, x, y,64,64);
          break;
        case 11:
          image(road11, x, y,64,64);
          break;
        case 12:
          image(road12, x, y,64,64);
          break;
        case 13:
          image(road13, x, y,64,64);
          break;
        case 14:
          image(road14, x, y,64,64);
          break;
        case 15:
          image(road15, x, y,64,64);
          break;
        case 16:
          image(road16, x, y,64,64);
          break;
      }
    }
  }
  class Alien extends Entity {
    int type;
    float time = 0;
    Alien(int x, int y, int typeTemp) {
      super(x+10,y+20); w = 44; h = 28;
      type = typeTemp;
      centerX = x+ 10; centerY = y+ 20;
      time = x*3 + y*2;
    }
    int centerX; int centerY;
    float xAccel = 0; float yAccel = 0;
    void update() {
      time+= 0.0045*period;
      switch (type) {
        case 0:
          x = (int) (centerX+sin(time)*64*1.5);
          break;
        case 1:
          y = (int) (centerY+sin(time)*64*1.5);
          break;
        case 2:
          x = (int) (centerX+sin(-time)*64*1.5);
          break;
        case 3:
          y = (int) (centerY+sin(-time)*64*1.5);
          break;
        case 4:
          x = (int)(centerX + 64*1.5 * sin(time));
          y = (int)(centerY + 64*1.5 * cos(time));
          break;
        case 5:
          if (car.x > x)
            xAccel+=0.0078*period;
          else
            xAccel-=0.0078*period;
          if (car.y > y)
            yAccel+=0.0078*period;
          else
            yAccel-=0.0078*period;
          if (yAccel>0.3*period) yAccel=0.3*period;
          if (yAccel<-0.3*period) yAccel=-0.3*period;
          if (xAccel>0.3*period) xAccel=0.3*period;
          if (xAccel<-0.3*period) xAccel=-0.3*period;
          x+=xAccel; y+=yAccel;
          break;
        case 6:
          if (car.x - 1 > x)
            x+=0.103*period;
          else if (car.x + 1 < x)
            x-=0.103*period;
          if (car.y - 1 > y)
            y+=0.103*period;
          else if (car.y + 1 < y)
            y-=0.103*period;
          break;
      }
    }
    void drawSprite() {
      if (type<=3)
        image(drone, x-10, y-134,32*2,84*2);
      else
        image(clone, x-10, y-134,32*2,84*2);
    }
  }
  public boolean touchingRoads(Entity e) {
    for (Road r : roads) {
      if (r.touching(e)&&!e.equals(r)) return true;
    }
    return false;
  }
  class Car extends Entity {
    Car(int x, int y) {
      super(x+18,y+18); w=22;h=22;
      x = x+18; y = y +18;
    }
    float v = 0.12;
    public void update() {
      if (isRight){xVel+=v*period;}
      if (isLeft){xVel-=v*period;}
      if (isUp){yVel+=v*period;}
      if (isDown){yVel-=v*period;}
      if (xVel > 0.18*period) xVel = 0.18*period;
      if (xVel < -0.18*period) xVel = -0.18*period;
      if (xVel > 0) {
        int times = (int)xVel; xVel--;
        while (times > 0) {
          x++; times--;
          if (get((int)(car.x+11),(int)(car.y+11))==-2270405) {
            times = 0; xVel = 0; x--;
          }
        }
      } else if (xVel < 0) {
        int times = (int)xVel; xVel++;
        while (times < 0) {
          x--; times++;
          if (get((int)(car.x+11),(int)(car.y+11))==-2270405) {
            times = 0; xVel = 0; x++;
          }
        }
      }
      
      if (yVel > 0.18*period) yVel = 0.18*period;
      if (yVel < -0.18*period) yVel = -0.18*period;
      if (yVel > 0) {
        int times = (int)yVel; yVel--;
        while (times > 0) {
          y++; times--;
          if (get((int)(car.x+11),(int)(car.y+11))==-2270405) {
            times = 0; yVel = 0; y--;
          }
        }
      } else if (yVel < 0) {
        int times = (int)yVel; yVel++;
        while (times < 0) {
          y--; times++;
          if (get((int)(car.x+11),(int)(car.y+11))==-2270405) {
            times = 0; yVel = 0; y++;
          }
        }
      }
      for (Entity e : aliens) {
        if (touching(e)) {
          if (!dead)
            abduct.play();
          dead = true;
          shouldGo = (int)(e.x+11); y = e.y+2;
          break;
        }
      }
      if (x>1066) {
        dead = true; won = true;
      }
      if (x<-3)
        x = -3;
    }
    float xVel = 0; float yVel = 0;
    int shouldGo = 0;
    void drawSprite() {
      if (level.fadeOut!=0&&!dead) {
        image(carRight, x, y,22,24);
        lastKey = RIGHT;
        return;
      }
      if (dead&!won) {
        y-=0.06*period;
        if (x>shouldGo)
          x-=0.06*period;
        else if (x<shouldGo)
          x+=0.06*period;
        switch((int)y/5%4) {
          case 0:
            image(carRight, x, y,22,24);
            break;
          case 1:
            image(carDown, x, y,22,24);
            break;
          case 2:
            image(carLeft, x, y,22,24);
            break;
          case 3:
            image(carUp, x, y,22,24);
            break;
        }
      } else if (won) {
        image(carRight, x, y,22,24);
      }
      else if (isUp)
        image(carDown, x, y,22,24);
      else if (isDown)
        image(carUp, x, y,22,24);
      else if (isLeft)
        image(carLeft, x, y,22,24);
      else if (isRight)
        image(carRight, x, y,22,24);
      else {
        switch (lastKey) {
          case UP:
            image(carUp, x, y,22,24);
            break;
          case DOWN:
            image(carDown, x, y,22,24);
            break;
          case LEFT:
            image(carLeft, x, y,22,24);
            break;
          case RIGHT:
            image(carRight, x, y,22,24);
            break;
        }
      }
    }
  }
  class Cactus extends Entity {
    Cactus(int x, int y) {
      super(x,y);
      randomOffset();
    }
    void update() {}
    void randomOffset() {
      randomSeed((int)x+(int)y);
      x+= random(-22,22);
      y+= random(-40,15);
    }
    void drawSprite() {
      if ((((int)x)/7+((int)y)/7)%3==0)
        image(cactus,x,y);
      else if ((((int)x)/7+((int)y)/7)%2==0)
        image(cactus3,x,y);
      else
        image(cactus2,x,y);
    }
  }
  public LinkedList<Road> roads = new LinkedList<Road>();
  public LinkedList<Alien> aliens = new LinkedList<Alien>();
  public LinkedList<Cactus> cacti = new LinkedList<Cactus>();
  public int fadeOut = 255;
  public Boolean dead = false;
  public Boolean won = false;
  void levelMods() {
    switch(lvlNum) {
      case 0:
        roads.add(new Road(-64,7*64));
        break;
      case 1:
        roads.add(new Road(-64,3*64));
        aliens.add(new Alien(6*64,7*64,2));
        aliens.add(new Alien(7*64,2*64,0));
        break;
      case 2:
        aliens.add(new Alien(9*64,5*64,4));
        roads.add(new Road(-64,5*64));
        break;
      case 3:
        roads.add(new Road(-64,4*64));
        aliens.add(new Alien(-5*64,4*64,6));
        break;
      case 4:
        roads.add(new Road(-64,5*64));
        aliens.add(new Alien(9*64,5*64,5));
        break;
      case 5:
        roads.add(new Road(-64,6*64));
        aliens.add(new Alien(5*64,6*64,2));
        aliens.add(new Alien(11*64,6*64,4));
        break;
      case 6:
        roads.add(new Road(-64,6*64));
    }
  }
  void readLevel() {
    dead = false;
    fadeOut = 255;
    reader = createReader("levels/" + lvlNum);
    try{ reader.readLine();
      do {
        int x = Integer.parseInt(reader.readLine());
        int y = 20-Integer.parseInt(reader.readLine());
        int type = Integer.parseInt(reader.readLine());
        int metadata = Integer.parseInt(reader.readLine());
        switch (type) {
          case 1:
            roads.add(new Road(x*64,y*64));
            break;
          case 2:
            aliens.add(new Alien(x*64,y*64,metadata));
            break;
          case 3:
            aliens.add(new Alien(x*64,y*64,metadata+4));
            break;
          case 4:
            cacti.add(new Cactus(x*64,y*64));
            break;
          case 5:
            car = new Car(x*64,y*64);
            roads.add(new Road(x*64,y*64));
        }
      } while (reader.ready());
      levelMods();
      for (Road r : roads) {r.reorient();}
      Collections.reverse(cacti);
      for (Alien a: aliens) {a.update();}
    } catch (IOException e) {}
  }
}

static class SoundManager {
  static Boolean stopping1 = false; //music
  static Boolean stopping2 = false; //music2
  static float vol1 = 1; static float vol2 = 1;
  public static void startSound(int flag) {
    switch(flag) {
      case 1:
        music.stop();
        music.loop();
        break;
      case 2:
        music2.stop();
        music2.play();
        break;
    }
  }
  public static void stopSound(int flag) {
    switch (flag) {
      case 1:
        stopping1 = true;
        break;
      case 2:
        stopping2 = true;
        break;
    }
  }
  public static void update() {
    if (stopping1) {
      vol1 -= 0.01;
    }
    if (stopping2) {
      vol2 -= 0.01;
    }
    if (vol1 < 0) {
      music.stop();
      stopping1 = false;
      vol1 = 1;
    }
    if (vol2 < 0) {
      music2.stop();
      stopping2 = false;
      vol2 = 1;
    }
    music.amp(vol1);
    music2.amp(vol2);
  }
}

class StoryDisplay {
  Boolean over = false;
  Boolean reallyOver = false;
  String story;
  String subString;
  int howFarInText;
  public Boolean update() {
    fill(#ffffff);
    if (level.lvlNum == 1) {
      textFont(font70);
      text("SWARM SAUCERS",100,100);
    }
    textFont(font26);
    text(subString + "|",200,150);
    if (!over) {
      if (subString.length()%(random.nextInt(6)+1)==0) {
        if (random.nextBoolean()) {
          type1.amp(random(0.2,0.5));
          type1.play();
        } else {
          type2.amp(random(0.2,0.5));
          type2.play();
        }
      }
      if (recentlyPressed) {
        //howFarInText += 5;
        howFarInText += 0.3*period;
      } else {
        //howFarInText++;
        howFarInText += 0.09*period;
      }
      if (highScore != 0)
        howFarInText += 6.6*period;
      try {
        subString = story.substring(0,(howFarInText/4));
      } catch (StringIndexOutOfBoundsException e) {
        over = true;
        subString = story;
      }
    } else {
      if (reallyOver&&recentlyPressed) {
        return true;
      }
      if (!recentlyPressed)
        reallyOver = true;
    }
    return false;
  }
  public void fadeText(int fadeTemp) {
    int fade = fadeTemp;
    if (fade<0) fade = 0;
    if (fade>255) fade = 255;
    fill(#ffffff,fade);
    if (level.lvlNum == 1) {
      textFont(font70);
      text("SWARM SAUCERS",100,100);
    }
    textFont(font26);
    text(story + "|",200,150);
  }
  StoryDisplay(int level) {
    howFarInText = 1;
    switch(level) {
      case 1:
        story = part1; break;
      case 2:
        story = part2; break;
      case 3:
        story = part3; break;
      case 4:
        story = part4; break;
      case 5:
        story = part5; break;
      case 6:
        story = part6; break;
    }
    subString = story.substring(0,howFarInText);
  }
  final String part1 = "        My name is Sean. I'm a cheese connoisseur. Anyway, let me tell\nyou the story.\n        I was driving through Sedona, Arizona on my way to a cheese\nconvention. In the trunk of my car was 300 pounds of gourmet goat\ncheese. It was then that I spotted them. I don't know why they were\ncoming after me. Maybe it was for the cheese. I certainly could\nunderstand that. They were giant flying saucers. Now, I know what\nyou're thinking. \"This cheese-man is nuts!\" And you know what? I\nreally do appreciate cheese with nuts.";
  final String part2 = "        I rolled down my window and yelled at the sky, \"All I have is\ncheese. Aged cheese!\" It didn't slow their pursuit. In fact, it seemed\nto speed it up. Those saucers were spinning faster than a butter\nchurner on the highest, cheese setting. I realized that I would have\nto drive for my life. Their tractor beams were sucking up sand and\nmaking these mini tornados.\n        One of the tornadoes got uncomfortably close to my vehicle, and\nin swerving to avoid it, I was surprised to see in the spaceship above,\nthrough one of its many, rotating windows, a face staring back at me\n- the face of a goat. I recognized him - his name was Goatface. I\ncracked open my window and cracked a smile at him.";
  final String part3 = "        \"Hey Goatface!\" I called. The goat did not look amused as he\npounded a hoofed fist on his control panel. The flying saucer lurched\ntoward me at full speed. I rolled up my window and floored it. It looked\nlike it was either me or the cheese, or something like that. I had to\nget to my cheese convention and share my delicious farmed cheese\nwith my fellow cheese connoisseurs - or die trying.";
  final String part4 = "        \"Surrender the stolen goat milk and live!\" The command broad-\ncasted as if through a loudspeaker from the mothership saucer. But\nI'm a guy who lives for cheese, so no way was I stopping. If only I\ncould reach that utopia of a cheese convention, these goats would be\nhelpless as our numbers of cheese lovers guzzled down all of the\ncheese.\n        \"I don't have any milk!\" I yelled into the air. \"It's all been fer-\nmented into cheese. Leave me alone.\" I nearly ran off the road with\nmy head out the window.\n        \"It matters little to us what form it is in,\" said a loud goat. \n\"You stole it from us, Farmer Sean, and we will rightfully take it\nback.\"";
  final String part5 = "        Then finally there it was, up ahead: the cheese convention. I\nrealized that my initial plan, of parking in the parking lot and hauling\nmy cheese into the convention by foot, wouldn't work - the goats\nwould have me and the cheese up by tractor beam quicker than a\nstick of butter on a Slip 'n Slide.\n        So I put my foot down hard on the gas pedal. If I could smash\nthrough the side of the building, we - and by 'we' I mean the cheese\nand I - would be safe under the roof. And we could eat the cheese! I\nmean me, I could eat the cheese, and everyone else could too. Or, I\nmean, everyone but not the goats, and the cheese wouldn't eat itself\neither.";
  final String part6 = "        My fellow cheese lovers were startled when a car burst through\ntheir wall, but I was even more startled when, though I thought I\nwas safe within the walls of the cheese convention, the ground began\nto shake. The goats were pulling the whole building up into space!";
}